/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.5 Professional
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 12/26/2007
Author  : engahmad                        
Company : BAU                             
Comments: 


Chip type           : ATmega16L
Program type        : Application
Clock frequency     : 7.372800 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

// CodeVisionAVR C Compiler
// (C) 1998-2001 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega16


#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb OCDR=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib


/* LCD driver routines

  CodeVisionAVR C Compiler
  (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE LCD IS CONNECTED!

  EXAMPLE FOR PORTB:

    #asm
        .equ __lcd_port=0x18
    #endasm
    #include <lcd.h>

*/


#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);
// write a byte to the LCD character generator or display RAM
void lcd_write_byte(unsigned char addr, unsigned char data);
// read a byte from the LCD character generator or display RAM
unsigned char lcd_read_byte(unsigned char addr);
// set the LCD display position  x=0..39 y=0..3
void lcd_gotoxy(unsigned char x, unsigned char y);
// clear the LCD
void lcd_clear(void);
void lcd_putchar(char c);
// write the string str located in SRAM to the LCD
void lcd_puts(char *str);
// write the string str located in FLASH to the LCD
void lcd_putsf(char flash *str);
// initialize the LCD controller
unsigned char lcd_init(unsigned char lcd_columns);

#pragma used-
#pragma library lcd.lib


/*
  CodeVisionAVR C Compiler
  (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.

  Prototypes for the Dallas Semiconductors
  DS1302 Real Time Clock functions

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  DS1302 IS CONNECTED AND
  THE DATA BITS USED FOR IO, SCLK and RST pins 

  EXAMPLE FOR PORTB:
    
  	#asm
        .equ __ds1302_port=0x18
        .equ __ds1302_io=2
        .equ __ds1302_sclk=1
        .equ __ds1302_rst=4
    #endasm
    #include <ds1302.h>
*/


#pragma used+

unsigned char ds1302_read(unsigned char addr);
void ds1302_write(unsigned char addr,unsigned char data);
void rtc_init(unsigned char tc_on,unsigned char diodes,unsigned char res);
void rtc_get_time(unsigned char *hour,unsigned char *min,unsigned char *sec);
void rtc_set_time(unsigned char hour,unsigned char min,unsigned char sec);
void rtc_get_date(unsigned char *date,unsigned char *month,unsigned char *year);
void rtc_set_date(unsigned char date,unsigned char month,unsigned char year);

#pragma used-
#pragma library ds1302.lib


#asm
   .equ __lcd_port=0x1B;PORTA
#endasm                                 
#asm
   .equ __ds1302_port=0x12 ;PORTD
   .equ __ds1302_io=6
   .equ __ds1302_sclk=5
   .equ __ds1302_rst=7
#endasm


// Declare your global variables here


// Define SPI-related pins


// SPSR

// SPCR




    

//******************************************************************
//*	Receive Ring Buffer Header Layout
//*   This is the 4-byte header that resides infront of the
//*   data packet in the receive buffer.
//******************************************************************
unsigned char  packetheader[6];
//******************************************************************
//*	Ethernet Header Layout
//******************************************************************
volatile unsigned char  packet[500];                
//******************************************************************
//*	IP Header Layout
//******************************************************************
//******************************************************************
//*	TCP Header Layout
//******************************************************************
//******************************************************************
//*	IP Protocol Types
//******************************************************************
//******************************************************************
//*	ICMP Header
//******************************************************************
//******************************************************************
//*	UDP Header
//******************************************************************
//#define	UDP_destport		   UDP_srcport+2
//#define	UDP_len				   UDP_destport+2
//#define	UDP_cksum			   UDP_len+2
//******************************************************************
//*	DHCP Message
//******************************************************************



//  Sn_MR values 

//  Sn_CR values 


//  Sn_SR values 
 

//*
//* socket register
//*
//*
//*	size of each channel register map
//*
//*
//* socket Mode register
//*
//*
//* channel Sn_CR register
//*
//*
//* channel interrupt register
//*
//*
//* channel status register
//*
//*
//* source port register
//*
//*
//* Peer MAC register address
//*
//*
//* Peer IP register address
//*
//*
//* Peer port register address
//*
//*
//* Maximum Segment Size(Sn_MSSR0) register address
//*
//*
//* Protocol of IP Header field register in IP raw mode
//*

//* 
//* IP Type of Service(TOS) Register 
//*
//*
//* IP Time to live(TTL) Register 
//*



//*
//* Transmit free memory size register
//*
//* Transmit memory read pointer register address
//*
//* Transmit memory write pointer register address
//*
//* Received data size register
//*
//*
//* Read point of Receive memory
//*
//*
//* Write point of Receive memory
//*

 

/*****************************************************
Socket Types
*****************************************************/
typedef enum
{
UDP=0x01,
TCP=0x02
}protocol; 
/*****************************************************
Socket Number
*****************************************************/
typedef enum
{
Sock0=0x00,
Sock1=0x01,
Sock2=0x02,
Sock3=0x03
}sock;
 

unsigned int  source_port_number;

/*****************************************************
Read and Write Functions
*****************************************************/

void initialize();      
unsigned char wiz_rd(unsigned int address) ;
void wiz_wr(unsigned int address, unsigned int targetValue);

unsigned char spi_transfer(volatile unsigned char data);                                   

/*****************************************************
Set Source Ip functions
*****************************************************/
void setGAR (unsigned char * addr);   
void setSUBR(unsigned char * addr);
void setSHAR(unsigned char * addr);
void setSIPR(unsigned char * addr);


/*****************************************************
TCP Functions
*****************************************************/

void open_socket(unsigned char socket_type,unsigned char socket_no,unsigned int port_no);
unsigned char Listen_TCP(unsigned char socket_no);
unsigned char Connect_TCP(unsigned char socket_no);
unsigned int get_sock_size(unsigned char socket_type,unsigned char socket_no);
unsigned int get_RD_offset(unsigned char socket_type,unsigned char socket_no); 
unsigned int get_WR_offset(unsigned char socket_type,unsigned char socket_no);
unsigned int check_TX_buffer(unsigned char socket_type,unsigned char socket_no);
void wr_dst_addr_TCP(unsigned char socket_no,unsigned char *config_dst_ip_address,unsigned char *config_dst_port_address );
void sock_close(unsigned char socket_type,unsigned char socket_no);
void check_disconnect(unsigned char socket_type,unsigned char socket_no);
void disconnect(unsigned char socket_type,unsigned char socket_no); 
void transmit(unsigned char socket_type,unsigned char socket_no,unsigned char get_size,unsigned char *packet); 
unsigned char recieve(unsigned char socket_type,unsigned char socket_no,unsigned char *packet);

/*****************************************************
Storing
*****************************************************/
void store(unsigned char *src,unsigned char *dest,unsigned char size);    
void store_int(unsigned char *src,unsigned char *dest,unsigned char size);

void main(void)
{   
unsigned int get_size;
unsigned char socket_no=0;
unsigned char config_gateway[4]; //= {192,168,0,1};
unsigned char config_subnet_mask[4] ;//= {255,255,255,0};
unsigned char config_mac_address[6] ;//= {0x02,0xDE,0xAD,0xBE,0xEF,0x00};
unsigned char config_ip_address[4] ;//= {192,168,0,3};
unsigned char config_dst_ip_address[4]; //= {192,168,0,5};
unsigned char default_config_gateway[4]= {192,168,0,1};
unsigned char default_config_subnet_mask[4] = {255,255,255,0};
unsigned char default_config_mac_address[6] = {0x02,0xDE,0xAD,0xBE,0xEF,0x00};
unsigned char default_config_ip_address[4] = {192,168,0,3};
unsigned char default_config_dst_ip_address[4]= {192,168,0,5};
unsigned char config_dst_port_address[] = {0,18};
unsigned char pass[4];
int i=0,j=0;
unsigned char a,b,c;
unsigned char buf[20];
unsigned char h,m,s;
unsigned char d,mm,y;
unsigned char minutes;
unsigned char h_temp,m_temp,s_temp;
unsigned char d_temp,mm_temp,y_temp;
unsigned int buf2[20];  
unsigned char mode;
unsigned char Authentication=0;
unsigned char ack1[2]={'O','K'};
unsigned char ack2[9]={'I','n','s','e','r','t',' ','I','P'};
unsigned char ack3[8]={'H','o','w',' ','l','o','n','g'};
unsigned char alarm1[13]={'M','o','t','i','o','n',' ','S','e','n','s','e','d'};
unsigned char count1,count2,count3,stage=1;
unsigned char dest_ip_temp[4]; 



rtc_init(1,1,3);
lcd_init(16);   

source_port_number=0x07; 
 
initialize();

init:

lcd_init(16); 
lcd_putsf("To insert num");
lcd_gotoxy(0,1);
lcd_putsf("     twice");
delay_ms(1000); 
lcd_clear(); 
lcd_putsf("Insert * ");
lcd_gotoxy(0,1);
lcd_putsf("eg:2* for 22");
delay_ms(2000); 
lcd_clear();
lcd_putsf("Pick 4 nums pass");



while(1)
{

co1omn1:    
c=a;
 //first column
PORTC =0x7f;//0111

//check for rows
if     (!(PINC & (1<<3))) { a=13;goto result;}
else if(!(PINC & (1<<2))) { a=2;goto result; }
else if(!(PINC & (1<<1))) { a=3;goto result; }
else if(!(PINC & (1<<0))) { a=4;goto result; } 
else goto co1omn2;
co1omn2:
//second column
PORTC =0xbf;//1011
if     (!(PINC & (1<<3))) { a=1;goto result; }
else if(!(PINC & (1<<2))) { a=6;goto result; }
else if(!(PINC & (1<<1))) { a=7;goto result; }
else if(!(PINC & (1<<0))) { a=8;goto result; }
else goto co1omn3; 
co1omn3:
//third column
PORTC =0xdf;//1101
if     (!(PINC & (1<<3))) { a=5;goto result;  }
else if(!(PINC & (1<<2))) { a=10;goto result; }
else if(!(PINC & (1<<1))) { a=11;goto result; }
else if(!(PINC & (1<<0))) { a=12;goto result; }
else goto co1omn4;  
co1omn4:
//fourth column
PORTC =0xef;//1110
if	   (!(PINC & (1<<3))) { a=9;goto result;  }
else if(!(PINC & (1<<2))) { a=14;goto result; }
else if(!(PINC & (1<<1))) { a=15;goto result; }
else if(!(PINC & (1<<0))) { a=16;goto result; } 
else goto co1omn1;    

result:

if(c!=a)
{

if(a==1)  {b=1;sprintf(buf,"%d", b);   lcd_puts(buf);}
if(a==2)  {b=4;sprintf(buf,"%d", b);   lcd_puts(buf);}
if(a==3)  {b=7;sprintf(buf,"%d", b);   lcd_puts(buf);}
if(a==4)  {b='*';sprintf(buf,"%c", b); lcd_puts(buf);}
if(a==5)  {b=2;sprintf(buf,"%d", b);   lcd_puts(buf);}
if(a==6)  {b=5;sprintf(buf,"%d", b);   lcd_puts(buf);}
if(a==7)  {b=8;sprintf(buf,"%d", b);   lcd_puts(buf);}
if(a==8)  {b=0;sprintf(buf,"%d", b);   lcd_puts(buf);}
if(a==9)  {b=3;sprintf(buf,"%d", b);   lcd_puts(buf);}
if(a==10) {b=6;sprintf(buf,"%d", b);   lcd_puts(buf);}
if(a==11) {b=9;sprintf(buf,"%d", b);   lcd_puts(buf);}
if(a==12) {b='.';sprintf(buf,"%c", b); lcd_puts(buf);}
if(a==13) {b='A';sprintf(buf,"%c", b); lcd_puts(buf);}
if(a==14) {b='B';sprintf(buf,"%c", b); lcd_puts(buf);}
if(a==15) {b='C';sprintf(buf,"%c", b); lcd_puts(buf);}
if(a==16) {b='D';sprintf(buf,"%c", b); lcd_puts(buf);}

begin:

switch(i) 
{
case 0:
    {
    pass[j++]=b;
    if(j==4) 
        {
        i++;
        lcd_clear();
        lcd_putsf("Set Date");
        lcd_gotoxy(0,1);
        lcd_putsf("Day/Month/Year");
        j=0;
        }
    goto co1omn1;
    }

case 1:
    { 
    buf2[j++]=b;      //Store the values to be written to the timekeeper DS1302
        if(j==1)
        {
            lcd_clear();
            lcd_puts(buf);
        }
    
        if(j==6)
        { 
        lcd_clear();
        lcd_putsf("Set Date");
        lcd_gotoxy(0,1);
        lcd_putsf("Hour/Min/Sec");    
        }  
        if(j==7)
        {   
            lcd_clear();
            lcd_puts(buf);
        }
            
        if(j==12)
        {   
            lcd_clear();
            for(j=0;j<12;j++)
            {
                if(buf2[j]=='*')
                    buf2[j]=buf2[j-1];
            }
            i++;
            j=0;
            rtc_set_date((buf2[j]*10+buf2[j+1]),(buf2[j+2]*10+buf2[j+3]),(buf2[j+4]*10+buf2[j+5]));
            rtc_set_time((buf2[j+6]*10+buf2[j+7]),(buf2[j+8]*10+buf2[j+9]),(buf2[j+10]*10+buf[j+11]));
            lcd_putsf("Set IPs ? y/n");
            //lcd_putsf("Set IP Address");
            lcd_gotoxy(0,1);
            lcd_putsf("y=1/n=2");
        }  
        
    goto co1omn1;

    }
    
case 2:
    {
    buf2[j++]=b;      
    if(buf2[j-1]==1)
        {
        i++;
        lcd_putsf("Set IP Address");
        lcd_gotoxy(0,1);
        
        } 
    else if(buf2[j-1]==2)    //use defaults
        {
        for(j=0;j<4;j++)
            {
            config_gateway[j]=default_config_gateway[j];
            config_subnet_mask[j] = default_config_subnet_mask[j];
            config_ip_address[j] = default_config_ip_address[j] ;
            config_dst_ip_address[j]= default_config_dst_ip_address[j]; 
            } 
        for(j=0;j<6;j++)
            config_mac_address[j]=default_config_mac_address[j]; 
        }
    else
        {
        i=0;
        lcd_putsf("Error");
        lcd_gotoxy(0,1);
        goto init;
        }
        j=0;
    goto co1omn1;
    }

case 3: 
    {   //set ip address
        buf2[j++]=b;
        if(buf2[j-1]=='A')          //termination
        {   
            lcd_clear();
            i++;
            j=0;   
            store(buf2,config_ip_address,j);
                    
            lcd_putsf("Subnet Mask");
            lcd_gotoxy(0,1);
                    
        }
                
            
           
        
            
        goto co1omn1;
    } 
case 4: 
    {
        buf2[j++]=b;
        if(buf2[j-1]=='A')          //termination
        {   
            lcd_clear();
            i++;   
            store(buf2,config_subnet_mask,j);
                    
            lcd_putsf("Default Gateway");
            lcd_gotoxy(0,1);
            j=0;
                    
        }
        goto co1omn1;
    }
    
case 5:
    {  
        buf2[j++]=b;
        if(buf2[j-1]=='A')          //termination
        {   
            lcd_clear();
            i++;   
            store(buf2,config_gateway,j);
                    
            lcd_putsf("Set Mac Address");
            lcd_gotoxy(0,1);
            j=0;
                    
        } 
        goto co1omn1;   
    }

case 6:
    {        
        buf2[j++]=b;
        if(buf2[j-1]=='A')          //termination
        {   
            lcd_clear();
            i++;   
            store(buf2,config_mac_address,j);
                    
            lcd_putsf("Server Address");
            lcd_gotoxy(0,1);
            j=0;
                    
        } 
        goto co1omn1;   

    }
case 7:
    {   
        buf2[j++]=b;
        if(buf2[j-1]=='A')          //termination
        {   
            lcd_clear();
            i++;   
            store(buf2,config_dst_ip_address,j);
            goto begin;        
                    
        }    

    } 
case 8:
    {
    lcd_clear();
    lcd_putsf("Starting........");
    goto tcp;
    }
        

}//end switch  
}//end if
}//end keypad loop


/*****************************************************
Initializition
*****************************************************/ 

operate:

  setGAR(config_gateway);              // Set default gateway
  setSUBR(config_subnet_mask);         // Set subnet mask
  setSHAR(config_mac_address);         // Set mac address
  setSIPR(config_ip_address);          // Set ip address

  PIND.2 =0;

tcp:


open_socket(TCP,Sock0,source_port_number);      //open a TCP socket
	
while (1)
{



if(PIND.2 )                                       //if Alarm is detected -> connect to server
{
    client_mode:
        mode=1;
        wr_dst_addr_TCP(Sock0,config_dst_ip_address,config_dst_port_address);
        Connect_TCP(Sock0);
}
else
{   
    server_mode:
        mode=2;
        Listen_TCP(Sock0); 
        while (wiz_rd(((0x0000 + 0x0400) + Sock0 * 0x0100 + 0x0003)) == 0x14		) 
            {
                if(PIND.2 )                                       //if Alarm is detected -> connect to server
                {  
                lcd_clear();
                lcd_putsf("Alarm Detected"); 
                goto tcp;               
                }
            };    //wait for request
}
     

/*****************************************************
Reading
*****************************************************/
       
       
  while (wiz_rd(((0x0000 + 0x0400) + Sock0 * 0x0100 + 0x0003)) == 0x17		) 
  { 
    Listen:  
    if(PIND.2 )                                       //if Alarm is detected -> connect to server
    {  
        lcd_clear();
        lcd_putsf("Alarm Detected"); 
        goto tcp;               
    }
    else
        if(mode==1)//  && !Alarm                  //souhld be rare but possible              //if mode ==1 and there is no alarm
        goto tcp; 
    lcd_clear();
    lcd_putsf("Waiting for data");
    
    rtc_get_date(&d,&mm,&y);
	rtc_get_time(&h,&m,&s);
	    
    if(h==h_temp && m>(m_temp+15+minutes) )           //If 15 minutes spent after alarm was detected and remained ,, retransmit alarm for other 5 minutes 
        {
        count2=1;                             //reset timing
        goto send_alarm;
        }        
    
  if(mode==2)                                       //if acting like a server eg: no alarm detected    
   while (wiz_rd(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0026)) != 0 || wiz_rd(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0027)) != 0)  //Check to know if data is received from remote peer or not.
   {  
    if(PIND.2 )                                       //if Alarm is detected -> connect to server
    {
        goto tcp;               
    }

    get_size=recieve(TCP,Sock0,packet);
    if(!get_size)   goto exit;   

if(!count1)                                   //if it is first attempt
if(packet[0x36 ]==pass[0])
if(packet[0x36 +1]==pass[1])
if(packet[0x36 +2]==pass[2])
if(packet[0x36 +3]==pass[3])
    {
    Authentication=1;               //password is correct
    count1=1;   
    for(i=0;i<2;i++)
    {
    packet[0x36 +i]=ack1[i];
    }    
    transmit(TCP,Sock0,2,packet);   //ack as OK 
    goto Listen;
    }

      

if(Authentication)                   //Start executing Commands
if(stage==1)
if(packet[0x36 ]=='d')         //first command "dstip change"
if(packet[0x36 +1]=='s')         //response is "Insert IP"
if(packet[0x36 +2]=='t')
if(packet[0x36 +3]=='i')
if(packet[0x36 +4]=='p')
if(packet[0x36 +5]==' ')
if(packet[0x36 +6]=='c')
if(packet[0x36 +7]=='h')
if(packet[0x36 +8]=='a')
if(packet[0x36 +9]=='n')
if(packet[0x36 +10]=='g')
if(packet[0x36 +11]=='e')
    {
    for(i=0;i<9;i++)
    {
    packet[0x36 +i]=ack2[i];
    }
    transmit(TCP,Sock0,9,packet);
    stage++; 
    goto Listen;   
    }                 

if(Authentication)                           //Get New destination IP number
if(stage==2) 
{
j=15;
for(i=0;packet[0x36 +i]!=' ';i++)
{
dest_ip_temp[i]=packet[0x36 +i];
};
dest_ip_temp[i]=' ';//add terminator         //i=size

store_int(dest_ip_temp,config_dst_ip_address,i);
for(i=0;i<2;i++)
{
packet[0x36 +i]=ack1[i];
}    
transmit(TCP,Sock0,2,packet);
stage=1;
goto Listen;                        //wait further commands
}                   


if(Authentication)                   //Start executing Commands
if(stage==1)
if(packet[0x36 ]=='t')         //second command "turn on lights"
if(packet[0x36 +1]=='u')         //response is "OK"
if(packet[0x36 +2]=='r')
if(packet[0x36 +3]=='n')
if(packet[0x36 +4]=='o')
if(packet[0x36 +5]=='n')
if(packet[0x36 +6]==' ')
if(packet[0x36 +7]=='l')
if(packet[0x36 +8]=='i')
if(packet[0x36 +9]=='g')
if(packet[0x36 +10]=='h')
if(packet[0x36 +11]=='t')
    {
    PORTD.4   =1;
    for(i=0;i<2;i++)
    {
    packet[0x36 +i]=ack1[i];
    }    
    transmit(TCP,Sock0,2,packet);   //ack as OK 
    goto Listen;
    }
    


if(Authentication)                   //Start executing Commands
if(stage==1)
if(packet[0x36 ]=='t')         //third command "turn off lights"
if(packet[0x36 +1]=='u')         //response is "OK"
if(packet[0x36 +2]=='r')
if(packet[0x36 +3]=='n')
if(packet[0x36 +4]=='o')
if(packet[0x36 +5]=='f')
if(packet[0x36 +6]=='f')
if(packet[0x36 +7]==' ')
if(packet[0x36 +8]=='l')
if(packet[0x36 +9]=='i')
if(packet[0x36 +10]=='g')
if(packet[0x36 +11]=='h')
if(packet[0x36 +12]=='t')
    {
    PORTD.4   =0;
    for(i=0;i<2;i++)
    {
    packet[0x36 +i]=ack1[i];
    }    
    transmit(TCP,Sock0,2,packet);   //ack as OK 
    goto Listen;
    }
    
    
if(Authentication)                   //Start executing Commands
if(stage==1)
if(packet[0x36 ]=='t')         //third command "turn on alarm"
if(packet[0x36 +1]=='u')         //response is "OK"
if(packet[0x36 +2]=='r')
if(packet[0x36 +3]=='n')
if(packet[0x36 +4]=='o')
if(packet[0x36 +5]=='n')
if(packet[0x36 +7]==' ')
if(packet[0x36 +8]=='a')
if(packet[0x36 +9]=='l')
if(packet[0x36 +10]=='a')
if(packet[0x36 +11]=='r')
if(packet[0x36 +12]=='m')
    {
    for(i=0;i<2;i++)
    {
    packet[0x36 +i]=ack2[i];
    }
    minutes=0;
    goto Listen;
    } 

if(Authentication)                   //Start executing Commands
if(stage==1)
if(packet[0x36 ]=='t')         //third command "turn off alarm"
if(packet[0x36 +1]=='u')         //response is "How long"
if(packet[0x36 +2]=='r')
if(packet[0x36 +3]=='n')
if(packet[0x36 +4]=='o')
if(packet[0x36 +5]=='f')
if(packet[0x36 +6]=='f')
if(packet[0x36 +7]==' ')
if(packet[0x36 +8]=='a')
if(packet[0x36 +9]=='l')
if(packet[0x36 +10]=='a')
if(packet[0x36 +11]=='r')
if(packet[0x36 +12]=='m')

    {
    for(i=0;i<8;i++)
    {
    packet[0x36 +i]=ack3[i];
    } 
    transmit(TCP,Sock0,8,packet);                  
    stage++;
    goto Listen;
    }

if(Authentication)                          //Get how long the alrarm would be turned off
if(stage==2)
{
minutes= packet[0x36 ];
for(i=0;i<2;i++)
{
packet[0x36 +i]=ack1[i];
}    
transmit(TCP,Sock0,2,packet);
stage=1;
goto Listen;                        //wait further commands
}          
    
if(Authentication)                   //Start executing Commands
if(stage==1)
if(packet[0x36 ]=='e')         //Last command "exit"
if(packet[0x36 +1]=='x')         //response is "OK"
if(packet[0x36 +2]=='i')
if(packet[0x36 +3]=='t')                                                                                 
    {
    for(i=0;i<2;i++)
    {
    packet[0x36 +i]=ack1[i];
    }
    transmit(TCP,Sock0,2,packet);
    Authentication=0;
    stage=0; 
    goto Listen;   
    } 
    
                                             
                                       
/*****************************************************
Client ,Alarm Activated , Motion Sensed
*****************************************************/ 
    
          
     }    //end while data recieved
     
     
    else  //mode=1                          //if client
     
     { 
     send_alarm: 
     if(!count2)                           //Set first alert time
        {
        rtc_get_date(&d_temp,&mm_temp,&y_temp);
	    rtc_get_time(&h_temp,&m_temp,&s_temp); 
	    count2=1;
        }
        
        rtc_get_date(&d,&mm,&y);
	    rtc_get_time(&h,&m,&s);
	    
        if(h==h_temp && m<(m_temp+5))           //keep alarm for only 5 minutes if human motion is still sensed 
        
	    for(i=0;i<13;i++)
        {
        packet[0x36 +i]=alarm1[i];
        }
        packet[0x36 +i]=' ';
        packet[0x36 +i+1]='i';
        packet[0x36 +i+2]='n';
        packet[0x36 +i+8]=' ';
        packet[0x36 +i+3]=d;
        packet[0x36 +i+4]='/';
        packet[0x36 +i+5]=mm;
        packet[0x36 +i+6]='/';
        packet[0x36 +i+7]=y;
        packet[0x36 +i+8]=' ';
        packet[0x36 +i+9]='a';
        packet[0x36 +i+10]='t';
        packet[0x36 +i+11]=' ';
        packet[0x36 +i+12]=h;
        packet[0x36 +i+13]=':';
        packet[0x36 +i+14]=m;
        packet[0x36 +i+15]=':';
        packet[0x36 +i+16]=s;
        
        transmit(TCP,Sock0,31,packet);
        goto Listen;
              
     }    //end else if alarm
     
     }     //end while SOCK_ESTABLISHED
     

    exit: check_disconnect(TCP,Sock0);
 
}; 


   
      
}

/*****************************************************
Initialization
*****************************************************/
void initialize()
{ 
  volatile unsigned char IOReg;
// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 115200
UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x03;


PORTA=0x00;
DDRA=0xFF;

DDRD.4=1;//Lights Relay
DDRD.2=0;//PIR

DDRC=0xF0;
PORTC=0xFF;
        
//   Configure I/O pins
  DDRB = (1<<5 ) | (1<<7 ) | (1<<4 );//OUTPUT
  DDRB &=~(1<<6 );                                             //INPUT
    
  PORTB |=  (1<<4 ) ;       // Disable slave
//SPI
  SPCR = (1<<6)| (1<<4);  //SPI Enable     //Master mode   
  IOReg   = SPSR;
  IOReg   = SPDR;
  delay_ms(10); 
//   Configure I/O pins
  DDRB  |=  (1<<0 ) ; // OUTPUT to control the wiznet reset 
  PORTB |=  (1<<0 ) ; // no reset 
  delay_ms(10);
  PORTB &= ~(1<<0 ) ; //reset the module
  delay_ms(10);
  PORTB |=  (1<<0 ) ; 
  delay_ms(10);
}   

/*****************************************************
Set Initial IP registers
*****************************************************/  

void setGAR(unsigned char *addr)
{
  // default gateway               
  wiz_wr((0x01 + 0),addr[0]);
  wiz_wr((0x01 + 1),addr[1]);     
  wiz_wr((0x01 + 2),addr[2]);   
  wiz_wr((0x01 + 3),addr[3]);   
}  

void setSUBR(unsigned char * addr)	/**< a pointer to a 4 -byte array responsible to set the SubnetMask address */
{
	wiz_wr((0x05 + 0),addr[0]);
	wiz_wr((0x05 + 1),addr[1]);
	wiz_wr((0x05 + 2),addr[2]);
	wiz_wr((0x05 + 3),addr[3]);
}                   

void setSHAR(unsigned char * addr)	/**< a pointer to a 6 -byte array responsible to set the MAC address. */
{
	wiz_wr((0x09 + 0),addr[0]);
	wiz_wr((0x09 + 1),addr[1]);
	wiz_wr((0x09 + 2),addr[2]);
	wiz_wr((0x09 + 3),addr[3]);
	wiz_wr((0x09 + 4),addr[4]);
	wiz_wr((0x09 + 5),addr[5]);
}

void setSIPR(unsigned char * addr)	/**< a pointer to a 4 -byte array responsible to set the Source IP address. */
{
	wiz_wr((0x0F   + 0),addr[0]);
	wiz_wr((0x0F   + 1),addr[1]);
	wiz_wr((0x0F   + 2),addr[2]);
	wiz_wr((0x0F   + 3),addr[3]);
}
/*****************************************************
Reading and Writing Wiznet Registers
*****************************************************/
unsigned char wiz_rd(unsigned int address) 
{  
 unsigned char data = 0x00;
 
 PORTB &= ~(1<<4 ) ; //enable slave
 
 spi_transfer(0x0F);
 spi_transfer((address>>8) & 0x00FF);
 spi_transfer(address& 0x00FF);
 data = spi_transfer(0xFF );

 PORTB |=  (1<<4 ) ;       // Disable slave
  
  return data;
}

void wiz_wr(unsigned int address, unsigned int targetValue) 
{
  
 PORTB &= ~(1<<4 ) ; //enable slave
 
 spi_transfer(0xF0);
 spi_transfer((address>>8) & 0x00FF); 
 spi_transfer(address & 0x00FF);
 spi_transfer(targetValue);

 PORTB |=  (1<<4 ) ;  // Disable slave 
}


   
/*****************************************************
SPI
*****************************************************/
unsigned char spi_transfer(volatile unsigned char data)
{
  SPDR = data;                    // Start the transmission
  while (!(SPSR & (1<<7  )));     // Wait for the end of the transmission
  return SPDR;                    // return the received byte     
}  
 /*****************************************************
Listening and Connecting
*****************************************************/


unsigned char Listen_TCP(unsigned char socket_no)
{ 
unsigned char ret;
	if (wiz_rd(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0003)) == 0x13		)
	{
		wiz_wr(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0001),0x02		);
		ret = 1;
	}
	else
	{
		ret = 0;
	}
return ret;
}  
unsigned char Connect_TCP(unsigned char socket_no)
{ 
unsigned char ret;
	if (wiz_rd(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0003)) == 0x13		)
	{
		wiz_wr(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0001),0x04		);
		ret = 1;
	}
	else
	{
		ret = 0;
	}
return ret;
}   

 /*****************************************************
Sockets
*****************************************************/

void open_socket(unsigned char socket_type,unsigned char socket_no,unsigned int port_no)  
 {
    if(socket_type==TCP)
	  {
	  do{   
	  wiz_wr(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0000),0x01		);				//protocol = TDP 
	  wiz_wr(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0004),(port_no>>8) & 0x00FF);				//well-know ECHO port
	  wiz_wr(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0005)    ,port_no & 0x00FF);        //set source port
	  wiz_wr(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0001),0x01		);			//give the open command   
	  if(wiz_rd(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0003)) != 0x13		)		//wait for the socket to come online
		  wiz_wr(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0001),0x10		);    //close socket if not open correctly
		} 
	  while(wiz_rd(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0003)) != 0x13		);
	  }
 }  

unsigned int get_sock_size(unsigned char socket_type,unsigned char socket_no) 	
{
unsigned int hi_byte,lo_byte,get_size;
  if(socket_type==TCP)
  {
   hi_byte = wiz_rd(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0026));              //get size of the packet in the "recieve size" register  RSR
	lo_byte = wiz_rd(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0027));              
	get_size = (((unsigned int)hi_byte & 0xFF)* 0x100) + ((unsigned int)lo_byte & 0x00FF);                     //make a 16 bit size 
	return get_size;
  }
}       

unsigned int get_WR_offset(unsigned char socket_type,unsigned char socket_no) 	
{ 
unsigned int hi_byte,lo_byte,get_offset;
  if(socket_type==TCP)
  {
  hi_byte = wiz_rd(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0024));           //Read the TX Write Pointer Register
	lo_byte = wiz_rd(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0025));
	get_offset = (((unsigned int)hi_byte & 0xFF)* 0x100) + ((unsigned int)lo_byte & 0x00FF) & 0x0800 - 1; // first 11 bits required of the offset
	return get_offset;
  }
}        	

unsigned int get_RD_offset(unsigned char socket_type,unsigned char socket_no) 	
{ 
unsigned int hi_byte,lo_byte,get_offset;
  if(socket_type==TCP)
  {
	hi_byte = wiz_rd(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0028));               // read the "RX read pointer" register value
	lo_byte = wiz_rd(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0029));         
	get_offset = (((unsigned int)hi_byte & 0xFF)* 0x100) + ((unsigned int)lo_byte & 0x00FF) & 0x0800 - 1;     // first 11 bits required of the offset
	return get_offset;
  }
}        

unsigned int check_TX_buffer(unsigned char socket_type,unsigned char socket_no)
{ 
unsigned int hi_byte,lo_byte,get_free_size; 
  if(socket_type==TCP)
  { 
    hi_byte = wiz_rd(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0020));          // Read Transmitter free size register
	  lo_byte = wiz_rd(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0021));
	  get_free_size = (((unsigned int)hi_byte & 0xFF)* 0x100) + ((unsigned int)lo_byte & 0x00FF);            //Get the TX Buffer Free size  
	  return get_free_size;
	  
  }
}

void wr_dst_addr_TCP(unsigned char socket_no,unsigned char *config_dst_ip_address,unsigned char *config_dst_port_address )
{  
unsigned int addri;
int i8;   
         addri = ((0x0000 + 0x0400) + socket_no * 0x0100 + 0x000C);                                //Get the address of the "destination IP address register"
	      for(i8=0;i8<4;++i8)
		   wiz_wr(addri++,config_dst_ip_address[i8]);//Write the destination IP address to send
	      addri = ((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0010);                               //Get the address of the "destination PORT address register"
	      for(i8=0;i8<2;++i8)
		      wiz_wr(addri++,config_dst_port_address[i8]);//Write the destination PORT address to send
}

/*****************************************************
Disconnecting
*****************************************************/ 

void sock_close(unsigned char socket_type,unsigned char socket_no) 
{
   if(socket_type==TCP)
      {
      wiz_wr(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0001),0x10		);        //close socket
      }   
} 

void check_disconnect(unsigned char socket_type,unsigned char socket_no)
{  
 if(socket_type==TCP)
   {
        if(wiz_rd(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0003)) == 0x1C		 || wiz_rd(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0003))==0x00		 ||wiz_rd(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0002))&0x0A )		
		   {
		   wiz_wr(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0001),0x10		);        //close socket
		   open_socket(TCP,socket_no,source_port_number);      //open a TCP socket
		   if(wiz_rd(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0002))&0x0A) 
		   wiz_wr(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0002),0x0A);//clear registers
		   printf("&");
		   }
   }
}

void disconnect(unsigned char socket_type,unsigned char socket_no)
{ 
   if(socket_type==TCP)
      wiz_wr(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0001),0x08		);        //close socket
}

/*****************************************************
Transmission and Reception
*****************************************************/ 

void transmit(unsigned char socket_type,unsigned char socket_no,unsigned char get_size,unsigned char *packet)
{   

unsigned int get_offset,get_start_address;
unsigned int get_free_size;
int i8;
unsigned int addri;    
     
      // first, get the free TX memory size 
      do
      {
         get_free_size=check_TX_buffer(TCP,Sock0);           //Get the TX Buffer Free size  
      }
      while(get_free_size < get_size);
   
      get_offset=get_WR_offset(TCP,Sock0);                //Get the write offset
  
	   get_start_address = 0x0000 + 0x4000 + get_offset;       //Get beginning address where the UDP data are stored
	   addri = get_start_address;     

//No need for more than 2 KBs in our application
/*	  
	   if ( (get_offset + get_size) > (gS0_RX_MASK + 1) ) //Sock0
         { 
           //store UDP header
	
           // copy upper_size bytes of get_start_address to destination_addr 
           upper_size = (gS0_RX_MASK + 1) - get_offset ;
	          for(i8=0;i8<upper_size;++i8)
	            {
		          		wiz_wr(addri++,packet[TCP_data+i8]);
		               ++get_offset;
	            }
            // copy left_size bytes of gSn_RX_BASE to destination_addr 
            left_size = get_size - upper_size; 

	         for(i8=0;i8<left_size;++i8)
	          {
		         wiz_wr(gS0_TX_BASE+i8,packet[TCP_data + upper_size+i8]);
	          }   
	

         }//end if  
      else      
 */	   
	   for(i8=0;i8<get_size;++i8)                     //Write the UDP data to the TX buffer
	   {
		   wiz_wr(addri++,packet[0x36 +i8]);
		   ++get_offset;
		   printf("-%c-",packet[0x36 +i8]);
	   }      
	   wiz_wr(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0024),(((unsigned int)get_offset >> (1 * 8)) & 0x00FF));
	   wiz_wr(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0025),(((unsigned int)get_offset >> (0 * 8)) & 0x00FF));
	   wiz_wr(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0001),0x20		);             //Send data
	   while(wiz_rd(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0001)));                  //wait for the data to be transmitted  
      
}    

unsigned char recieve(unsigned char socket_type,unsigned char socket_no,unsigned char *packet)
{                  
      
unsigned int get_size, get_offset,get_start_address;
int i8;
unsigned int addri;
      get_size=get_sock_size(TCP,Sock0);                      //get the socket size  
      if(get_size==2048)                                      //at very rare situations this happens ,,it killed me
        {
            wiz_wr(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0001),0x08		);
            return 0;    
        } 
	 printf("-3-");
	   get_offset=get_RD_offset(TCP,socket_no);                  //get the read offset
	   get_start_address = 0x0000 + 0x6000 + get_offset;           //Get beginning address of the UDP packets header
        printf("-4-");
      addri = get_start_address; 	
      
//No need for more than 2 KBs in our application 
     
/*    // if overflow socket RX memory   
      if ( (get_offset + get_size) > (gS0_RX_MASK + 1) ) //Sock0
      {      
        printf("-*-"); printf("+%d+",get_size);
            //store UDP header
	
            // copy upper_size bytes of get_start_address to destination_addr 
            upper_size = (gS0_RX_MASK + 1) - get_offset ;
	            for(i8=0;i8<upper_size;++i8)
	            {
		            packet[TCP_data+i8] = wiz_rd(addri++);
	            }
               // copy left_size bytes of gSn_RX_BASE to destination_addr 
               left_size = get_size - upper_size; 

	            for(i8=0;i8<left_size;++i8)
	               {
		            packet[TCP_data + upper_size+i8] = wiz_rd(gS0_TX_BASE+i8);
	               }   
	

       }//end if 
       
       
      //else      */

// copy get_size bytes of get_start_address to destination_addr 
	         for(i8=0;i8<get_size;++i8)
	            {
		            packet[0x36 +i8] = wiz_rd(addri++);
		            ++get_offset; 
		            printf("-%d-",i8);
	            }          
	         printf("-6-");
            // increase Sn_RX_RD as length of get_size 
             printf("-7-");
         	wiz_wr(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0028),(((unsigned int)get_offset >> (1 * 8)) & 0x00FF));
	         wiz_wr(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0029),(((unsigned int)get_offset >> (0 * 8)) & 0x00FF));
	    
	          printf("-8-");
      wiz_wr(((0x0000 + 0x0400) + socket_no * 0x0100 + 0x0001),0x40		);             //reset recieved data interrupt bit  
	  return get_size; 
}
      
/*****************************************************
Storing Arrays
*****************************************************/ 

void store(unsigned char *src,unsigned char *dest,unsigned char size)
{
int k,l=0,b=0;
for(k=0;k<size;k++)
            {   
                if(src[k]=='*')
                    src[k]=src[k-1];
                if(src[k]=='.' || src[k]=='A'/*Termination*/)
                    {
                    if(!b)              //first number ,b points to first digit
                    switch (k-b)        
                        {
                        case 1:  // 1 digit
                            dest[l++]=src[k-1];
                            break;
                    
                        case 2:  // 2 digits
                            dest[l++]=src[k-1]+src[k-2]*10;
                            break;
                        case 3:  // 3 digits
                            dest[l++]=src[k-1]+src[k-2]*10+src[k-3]*100; 
                            break;
                        }
                    else
                    switch (k-b)     //the rest ,b points to '.'
                        {
                        case 2:  // 1 digit
                            dest[l++]=src[k-1];
                            break;
                    
                        case 3:  // 2 digits
                            dest[l++]=src[k-1]+src[k-2]*10;
                            break;
                        case 4:  // 3 digits
                            dest[l++]=src[k-1]+src[k-2]*10+src[k-3]*100; 
                            break;
                        }
                     } 
                }
}	

void store_int(unsigned char *src,unsigned char *dest,unsigned char size)
{
int k,l=0,b=0;
for(k=0;k<size;k++)
            {   
                
                if(src[k]=='.' || src[k]==' '/*Termination*/)
                    {
                    if(!b)              //first number ,b points to first digit
                    switch (k-b)        
                        {
                        case 1:  // 1 digit
                            dest[l++]=src[k-1];
                            break;
                    
                        case 2:  // 2 digits
                            dest[l++]=src[k-1]+src[k-2]*10;
                            break;
                        case 3:  // 3 digits
                            dest[l++]=src[k-1]+src[k-2]*10+src[k-3]*100; 
                            break;
                        }
                    else
                    switch (k-b)     //the rest ,b points to '.'
                        {
                        case 2:  // 1 digit
                            dest[l++]=src[k-1];
                            break;
                    
                        case 3:  // 2 digits
                            dest[l++]=src[k-1]+src[k-2]*10;
                            break;
                        case 4:  // 3 digits
                            dest[l++]=src[k-1]+src[k-2]*10+src[k-3]*100; 
                            break;
                        }
                     } 
                }
}	


