/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.5 Professional
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project :
Version :
Date    : 12/26/2007
Author  : engahmad
Company : BAU
Comments:


Chip type           : ATmega16L
Program type        : Application
Clock frequency     : 7.372800 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega16.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#include <delay.h>
#include <stdio.h>
#include<Lcd.h>
#include <ds1302.h>
#asm
   .equ __lcd_port=0x1B;PORTA
#endasm
#asm
   .equ __ds1302_port=0x12 ;PORTD
   .equ __ds1302_io=6
   .equ __ds1302_sclk=5
   .equ __ds1302_rst=7
#endasm

#define CHECKBIT(ADDRESS,BIT) (ADDRESS & (1<<BIT))

// Declare your global variables here

#define Alarm  PIND.2
#define light PORTD.4

// Define SPI-related pins

#define SCK  7 // (Serial Clock)
#define MISO  6 //(Master In / Slave Out)
#define MOSI 5 // (Master Out / Slave In)
#define SLAVE_SELECT 4 // SS (Slave Select)

// SPSR
#define SPIF 7

// SPCR
#define SPE 6
#define MSTR 4
#define CPHA 2
#define SPR0 0


#define PIN_RESET 0 // WIZnet module /RESET

#define WIZNET_OPCODE_READ 0x0F
#define WIZNET_OPCODE_WRITE 0xF0

#define DUMMY_DATA 0xFF

#define make8(var,offset)	((unsigned int)var >> (offset * 8)) & 0x00FF
#define	make16(varhigh,varlow)	(((unsigned int)varhigh & 0xFF)* 0x100) + ((unsigned int)varlow & 0x00FF)
#define make32(var1,var2,var3,var4) \((unsigned long)var1<<24)+((unsigned long)var2<<16)+ \((unsigned long)var3<<8)+((unsigned long)var4)

#define chip_base_address 		0x0000
#define RX_memory_base_address	0x6000
#define gS0_RX_BASE 			chip_base_address + RX_memory_base_address
#define gS0_RX_MASK				0x0800 - 1
#define gS1_RX_BASE				gS0_RX_BASE + (gS0_RX_MASK + 1)
#define gS1_RX_MASK				0x0800 - 1
#define gS2_RX_BASE				gS1_RX_BASE + (gS1_RX_MASK + 1)
#define gS2_RX_MASK				0x0800 - 1
#define gS3_RX_BASE				gS2_RX_BASE + (gS2_RX_MASK + 1)
#define gS3_RX_MASK				0x0800 - 1
#define TX_memory_base_address	0x4000
#define gS0_TX_BASE 			chip_base_address + TX_memory_base_address
#define gS0_TX_MASK				0x0800 - 1
#define gS1_TX_BASE				gS0_TX_BASE + (gS0_TX_MASK + 1)
#define gS1_TX_MASK				0x0800 - 1
#define gS2_TX_BASE				gS1_TX_BASE + (gS1_TX_MASK + 1)
#define gS2_TX_MASK				0x0800 - 1
#define gS3_TX_BASE				gS2_TX_BASE + (gS2_TX_MASK + 1)
#define gS3_TX_MASK				0x0800 - 1

//******************************************************************
//*	Receive Ring Buffer Header Layout
//*   This is the 4-byte header that resides infront of the
//*   data packet in the receive buffer.
//******************************************************************
unsigned char  packetheader[6];
//******************************************************************
//*	Ethernet Header Layout
//******************************************************************
volatile unsigned char  packet[500];
//******************************************************************
//*	IP Header Layout
//******************************************************************
#define	ip_srcaddr		   0x1A	//IP address of source
#define	ip_destaddr		   0x1E	//IP addess of destination
#define	ip_data			   0x22	//IP data area
//******************************************************************
//*	TCP Header Layout
//******************************************************************
#define	TCP_srcport		   0x22	//TCP source port
#define	TCP_destport   	   0x24	//TCP destination port
#define	TCP_seqnum  	   0x26	//sequence number
#define	TCP_acknum	       0x2A	//acknowledgement number
#define	TCP_hdrflags	   0x2E	//4-bit header len and flags
#define	TCP_window		   0x30	//window size
#define	TCP_cksum		   0x32	//TCP checksum
#define	TCP_urgentptr      0x34	//urgent pointer
#define TCP_data           0x36 //option/data
//******************************************************************
//*	IP Protocol Types
//******************************************************************
#define	PROT_ICMP			   0x01
#define	PROT_TCP			   0x06
#define	PROT_UDP			   0x11
//******************************************************************
//*	ICMP Header
//******************************************************************
#define	ICMP_type			   ip_data
#define	ICMP_code			   ICMP_type+1
#define	ICMP_cksum			   ICMP_code+1
#define	ICMP_id				   ICMP_cksum+2
#define	ICMP_seqnum			   ICMP_id+2
#define ICMP_data              ICMP_seqnum+2
//******************************************************************
//*	UDP Header
//******************************************************************
#define	UDP_srcport			   ip_data
//#define	UDP_destport		   UDP_srcport+2
//#define	UDP_len				   UDP_destport+2
//#define	UDP_cksum			   UDP_len+2
#define	UDP_data			   UDP_srcport+2
//******************************************************************
//*	DHCP Message
//******************************************************************
#define	DHCP_op					UDP_data
#define	DHCP_htype				DHCP_op+1
#define DHCP_hlen				DHCP_htype+1
#define DHCP_hops				DHCP_hlen+1
#define DHCP_xid				DHCP_hops+1
#define DHCP_secs				DHCP_xid+4
#define DHCP_flags				DHCP_secs+2
#define DHCP_ciaddr				DHCP_flags+2
#define DHCP_yiaddr				DHCP_ciaddr+4
#define DHCP_siaddr				DHCP_yiaddr+4
#define DHCP_giaddr				DHCP_siaddr+4
#define DHCP_chaddr				DHCP_giaddr+4
#define DHCP_sname				DHCP_chaddr+16
#define DHCP_file				DHCP_sname+64
#define DHCP_options			DHCP_file+128
#define DHCP_message_end		DHCP_options+312

#define COMMON_BASE	0x0000

#define GAR0			0x01
#define SUBR0			0x05
#define SHAR0			0x09
#define SIPR0			0x0F
#define IR				0x15
#define IMR			  0x16
#define RTR0			0x17

//  Sn_MR values
#define Sn_MR_CLOSE		0x00		// unused socket
#define Sn_MR_TCP		0x01		// TCP
#define Sn_MR_UDP		0x02		// UDP
#define Sn_MR_IPRAW	0x03		// IP LAYER RAW SOCK
#define Sn_MR_MACRAW	0x04		// MAC LAYER RAW SOCK
#define Sn_MR_PPPOE		0x05		// PPPoE
#define Sn_MR_ND		0x20		// No Delayed Ack(TCP) flag
#define Sn_MR_MULTI		0x80		// support multicating

//  Sn_CR values
#define Sn_CR_OPEN		0x01		// initialize or open socket
#define Sn_CR_LISTEN		0x02		// wait connection request in tcp mode(Server mode)
#define Sn_CR_CONNECT	0x04		// send connection request in tcp mode(Client mode)
#define Sn_CR_DISCON		0x08		// send closing reqeuset in tcp mode
#define Sn_CR_CLOSE		0x10		// close socket
#define Sn_CR_SEND		0x20		// updata txbuf pointer, send data
#define Sn_CR_SEND_MAC	0x21		// send data with MAC address, so without ARP process
#define Sn_CR_SEND_KEEP	0x22		//  send keep alive message
#define Sn_CR_RECV		0x40		// update rxbuf pointer, recv data


//  Sn_SR values
#define SOCK_CLOSED				0x00		// closed
#define SOCK_INIT 				0x13		// init state
#define SOCK_LISTEN				0x14		// listen state
#define SOCK_SYNSENT	   		0x15		// connection state
#define SOCK_SYNRECV		   	0x16		// connection state
#define SOCK_ESTABLISHED		0x17		// success to connect
#define SOCK_FIN_WAIT			0x18		// closing state
#define SOCK_CLOSING		   	0x1A		// closing state
#define SOCK_TIME_WAIT			0x1B		// closing state
#define SOCK_CLOSE_WAIT			0x1C		// closing state
#define SOCK_LAST_ACK			0x1D		// closing state
#define SOCK_UDP				   0x22		// udp socket
#define SOCK_IPRAW			   0x32		// ip raw mode socket
#define SOCK_MACRAW			   0x42		// mac raw mode socket
#define SOCK_PPPOE				0x5F		// pppoe socket


//*
//* socket register
//*
#define CH_BASE (COMMON_BASE + 0x0400)
//*
//*	size of each channel register map
//*
#define CH_SIZE		0x0100
//*
//* socket Mode register
//*
#define Sn_MR(ch)		(CH_BASE + ch * CH_SIZE + 0x0000)
//*
//* channel Sn_CR register
//*
#define Sn_CR(ch)				(CH_BASE + ch * CH_SIZE + 0x0001)
//*
//* channel interrupt register
//*
#define Sn_IR(ch)			(CH_BASE + ch * CH_SIZE + 0x0002)
//*
//* channel status register
//*
#define Sn_SR(ch)			(CH_BASE + ch * CH_SIZE + 0x0003)
//*
//* source port register
//*
#define Sn_PORT0(ch)		(CH_BASE + ch * CH_SIZE + 0x0004)
#define Sn_PORT1(ch)		(CH_BASE + ch * CH_SIZE + 0x0005)
//*
//* Peer MAC register address
//*
#define Sn_DHAR0(ch)			(CH_BASE + ch * CH_SIZE + 0x0006)
//*
//* Peer IP register address
//*
#define Sn_DIPR0(ch)			(CH_BASE + ch * CH_SIZE + 0x000C)
//*
//* Peer port register address
//*
#define Sn_DPORT0(ch)		(CH_BASE + ch * CH_SIZE + 0x0010)
//*
//* Maximum Segment Size(Sn_MSSR0) register address
//*
#define Sn_MSSR0(ch)					(CH_BASE + ch * CH_SIZE + 0x0012)
//*
//* Protocol of IP Header field register in IP raw mode
//*
#define Sn_PROTO(ch)			(CH_BASE + ch * CH_SIZE + 0x0014)

//*
//* IP Type of Service(TOS) Register
//*
#define Sn_TOS(ch)						(CH_BASE + ch * CH_SIZE + 0x0015)
//*
//* IP Time to live(TTL) Register
//*
#define Sn_TTL(ch)						(CH_BASE + ch * CH_SIZE + 0x0016)



//*
//* Transmit free memory size register
//*
#define Sn_TX_FSR0(ch)	(CH_BASE + ch * CH_SIZE + 0x0020)
#define Sn_TX_FSR1(ch)	(CH_BASE + ch * CH_SIZE + 0x0021)
//* Transmit memory read pointer register address
//*
#define Sn_TX_RD0(ch)			(CH_BASE + ch * CH_SIZE + 0x0022)
#define Sn_TX_RD1(ch)			(CH_BASE + ch * CH_SIZE + 0x0023)
//* Transmit memory write pointer register address
//*
#define Sn_TX_WR0(ch)			(CH_BASE + ch * CH_SIZE + 0x0024)
#define Sn_TX_WR1(ch)			(CH_BASE + ch * CH_SIZE + 0x0025)
//* Received data size register
//*
#define Sn_RX_RSR0(ch)	(CH_BASE + ch * CH_SIZE + 0x0026)
#define Sn_RX_RSR1(ch)	(CH_BASE + ch * CH_SIZE + 0x0027)
//*
//* Read point of Receive memory
//*
#define Sn_RX_RD0(ch)			(CH_BASE + ch * CH_SIZE + 0x0028)
#define Sn_RX_RD1(ch)			(CH_BASE + ch * CH_SIZE + 0x0029)
//*
//* Write point of Receive memory
//*
#define Sn_RX_WR0(ch)			(CH_BASE + ch * CH_SIZE + 0x002A)



/*****************************************************
Socket Types
*****************************************************/
typedef enum
{
UDP=0x01,
TCP=0x02
}protocol;
/*****************************************************
Socket Number
*****************************************************/
typedef enum
{
Sock0=0x00,
Sock1=0x01,
Sock2=0x02,
Sock3=0x03
}sock;


unsigned int  source_port_number;

/*****************************************************
Read and Write Functions
*****************************************************/

void initialize();
unsigned char wiz_rd(unsigned int address) ;
void wiz_wr(unsigned int address, unsigned int targetValue);

unsigned char spi_transfer(volatile unsigned char data);

/*****************************************************
Set Source Ip functions
*****************************************************/
void setGAR (unsigned char * addr);
void setSUBR(unsigned char * addr);
void setSHAR(unsigned char * addr);
void setSIPR(unsigned char * addr);


/*****************************************************
TCP Functions
*****************************************************/

void open_socket(unsigned char socket_type,unsigned char socket_no,unsigned int port_no);
unsigned char Listen_TCP(unsigned char socket_no);
unsigned char Connect_TCP(unsigned char socket_no);
unsigned int get_sock_size(unsigned char socket_type,unsigned char socket_no);
unsigned int get_RD_offset(unsigned char socket_type,unsigned char socket_no);
unsigned int get_WR_offset(unsigned char socket_type,unsigned char socket_no);
unsigned int check_TX_buffer(unsigned char socket_type,unsigned char socket_no);
void wr_dst_addr_TCP(unsigned char socket_no,unsigned char *config_dst_ip_address,unsigned char *config_dst_port_address );
void sock_close(unsigned char socket_type,unsigned char socket_no);
void check_disconnect(unsigned char socket_type,unsigned char socket_no);
void disconnect(unsigned char socket_type,unsigned char socket_no);
void transmit(unsigned char socket_type,unsigned char socket_no,unsigned char get_size,unsigned char *packet);
unsigned char recieve(unsigned char socket_type,unsigned char socket_no,unsigned char *packet);

/*****************************************************
Storing
*****************************************************/
void store(unsigned char *src,unsigned char *dest,unsigned char size);
void store_int(unsigned char *src,unsigned char *dest,unsigned char size);

void main(void)
{
unsigned int get_size;
unsigned char socket_no=0;
unsigned char config_gateway[4]; //= {192,168,0,1};
unsigned char config_subnet_mask[4] ;//= {255,255,255,0};
unsigned char config_mac_address[6] ;//= {0x02,0xDE,0xAD,0xBE,0xEF,0x00};
unsigned char config_ip_address[4] ;//= {192,168,0,3};
unsigned char config_dst_ip_address[4]; //= {192,168,0,5};
unsigned char default_config_gateway[4]= {192,168,0,1};
unsigned char default_config_subnet_mask[4] = {255,255,255,0};
unsigned char default_config_mac_address[6] = {0x02,0xDE,0xAD,0xBE,0xEF,0x00};
unsigned char default_config_ip_address[4] = {192,168,0,3};
unsigned char default_config_dst_ip_address[4]= {192,168,0,5};
unsigned char config_dst_port_address[] = {0,18};
unsigned char pass[4];
int i=0,j=0;
unsigned char a,b,c;
unsigned char buf[20];
unsigned char h,m,s;
unsigned char d,mm,y;
unsigned char minutes;
unsigned char h_temp,m_temp,s_temp;
unsigned char d_temp,mm_temp,y_temp;
unsigned int buf2[20];
unsigned char mode;
unsigned char Authentication=0;
unsigned char ack1[2]={'O','K'};
unsigned char ack2[9]={'I','n','s','e','r','t',' ','I','P'};
unsigned char ack3[8]={'H','o','w',' ','l','o','n','g'};
unsigned char alarm1[13]={'M','o','t','i','o','n',' ','S','e','n','s','e','d'};
unsigned char count1,count2,count3,stage=1;
unsigned char dest_ip_temp[4];



rtc_init(1,1,3);
lcd_init(16);

source_port_number=0x07;

initialize();

init:

lcd_init(16);
lcd_putsf("To insert num");
lcd_gotoxy(0,1);
lcd_putsf("     twice");
delay_ms(1000);
lcd_clear();
lcd_putsf("Insert * ");
lcd_gotoxy(0,1);
lcd_putsf("eg:2* for 22");
delay_ms(2000);
lcd_clear();
lcd_putsf("Pick 4 nums pass");



while(1)
{

co1omn1:
c=a;
 //first column
PORTC =0x7f;//0111

//check for rows
if     (!CHECKBIT(PINC,3)) { a=13;goto result;}
else if(!CHECKBIT(PINC,2)) { a=2;goto result; }
else if(!CHECKBIT(PINC,1)) { a=3;goto result; }
else if(!CHECKBIT(PINC,0)) { a=4;goto result; }
else goto co1omn2;
co1omn2:
//second column
PORTC =0xbf;//1011
if     (!CHECKBIT(PINC,3)) { a=1;goto result; }
else if(!CHECKBIT(PINC,2)) { a=6;goto result; }
else if(!CHECKBIT(PINC,1)) { a=7;goto result; }
else if(!CHECKBIT(PINC,0)) { a=8;goto result; }
else goto co1omn3;
co1omn3:
//third column
PORTC =0xdf;//1101
if     (!CHECKBIT(PINC,3)) { a=5;goto result;  }
else if(!CHECKBIT(PINC,2)) { a=10;goto result; }
else if(!CHECKBIT(PINC,1)) { a=11;goto result; }
else if(!CHECKBIT(PINC,0)) { a=12;goto result; }
else goto co1omn4;
co1omn4:
//fourth column
PORTC =0xef;//1110
if	   (!CHECKBIT(PINC,3)) { a=9;goto result;  }
else if(!CHECKBIT(PINC,2)) { a=14;goto result; }
else if(!CHECKBIT(PINC,1)) { a=15;goto result; }
else if(!CHECKBIT(PINC,0)) { a=16;goto result; }
else goto co1omn1;

result:

if(c!=a)
{

if(a==1)  {b=1;sprintf(buf,"%d", b);   lcd_puts(buf);}
if(a==2)  {b=4;sprintf(buf,"%d", b);   lcd_puts(buf);}
if(a==3)  {b=7;sprintf(buf,"%d", b);   lcd_puts(buf);}
if(a==4)  {b='*';sprintf(buf,"%c", b); lcd_puts(buf);}
if(a==5)  {b=2;sprintf(buf,"%d", b);   lcd_puts(buf);}
if(a==6)  {b=5;sprintf(buf,"%d", b);   lcd_puts(buf);}
if(a==7)  {b=8;sprintf(buf,"%d", b);   lcd_puts(buf);}
if(a==8)  {b=0;sprintf(buf,"%d", b);   lcd_puts(buf);}
if(a==9)  {b=3;sprintf(buf,"%d", b);   lcd_puts(buf);}
if(a==10) {b=6;sprintf(buf,"%d", b);   lcd_puts(buf);}
if(a==11) {b=9;sprintf(buf,"%d", b);   lcd_puts(buf);}
if(a==12) {b='.';sprintf(buf,"%c", b); lcd_puts(buf);}
if(a==13) {b='A';sprintf(buf,"%c", b); lcd_puts(buf);}
if(a==14) {b='B';sprintf(buf,"%c", b); lcd_puts(buf);}
if(a==15) {b='C';sprintf(buf,"%c", b); lcd_puts(buf);}
if(a==16) {b='D';sprintf(buf,"%c", b); lcd_puts(buf);}

begin:

switch(i)
{
case 0:
    {
    pass[j++]=b;
    if(j==4)
        {
        i++;
        lcd_clear();
        lcd_putsf("Set Date");
        lcd_gotoxy(0,1);
        lcd_putsf("Day/Month/Year");
        j=0;
        }
    goto co1omn1;
    }

case 1:
    {
    buf2[j++]=b;      //Store the values to be written to the timekeeper DS1302
        if(j==1)
        {
            lcd_clear();
            lcd_puts(buf);
        }

        if(j==6)
        {
        lcd_clear();
        lcd_putsf("Set Date");
        lcd_gotoxy(0,1);
        lcd_putsf("Hour/Min/Sec");
        }
        if(j==7)
        {
            lcd_clear();
            lcd_puts(buf);
        }

        if(j==12)
        {
            lcd_clear();
            for(j=0;j<12;j++)
            {
                if(buf2[j]=='*')
                    buf2[j]=buf2[j-1];
            }
            i++;
            j=0;
            rtc_set_date((buf2[j]*10+buf2[j+1]),(buf2[j+2]*10+buf2[j+3]),(buf2[j+4]*10+buf2[j+5]));
            rtc_set_time((buf2[j+6]*10+buf2[j+7]),(buf2[j+8]*10+buf2[j+9]),(buf2[j+10]*10+buf[j+11]));
            lcd_putsf("Set IPs ? y/n");
            //lcd_putsf("Set IP Address");
            lcd_gotoxy(0,1);
            lcd_putsf("y=1/n=2");
        }

    goto co1omn1;

    }

case 2:
    {
    buf2[j++]=b;
    if(buf2[j-1]==1)
        {
        i++;
        lcd_putsf("Set IP Address");
        lcd_gotoxy(0,1);

        }
    else if(buf2[j-1]==2)    //use defaults
        {
        for(j=0;j<4;j++)
            {
            config_gateway[j]=default_config_gateway[j];
            config_subnet_mask[j] = default_config_subnet_mask[j];
            config_ip_address[j] = default_config_ip_address[j] ;
            config_dst_ip_address[j]= default_config_dst_ip_address[j];
            }
        for(j=0;j<6;j++)
            config_mac_address[j]=default_config_mac_address[j];
        }
    else
        {
        i=0;
        lcd_putsf("Error");
        lcd_gotoxy(0,1);
        goto init;
        }
        j=0;
    goto co1omn1;
    }

case 3:
    {   //set ip address
        buf2[j++]=b;
        if(buf2[j-1]=='A')          //termination
        {
            lcd_clear();
            i++;
            j=0;
            store(buf2,config_ip_address,j);

            lcd_putsf("Subnet Mask");
            lcd_gotoxy(0,1);

        }





        goto co1omn1;
    }
case 4:
    {
        buf2[j++]=b;
        if(buf2[j-1]=='A')          //termination
        {
            lcd_clear();
            i++;
            store(buf2,config_subnet_mask,j);

            lcd_putsf("Default Gateway");
            lcd_gotoxy(0,1);
            j=0;

        }
        goto co1omn1;
    }

case 5:
    {
        buf2[j++]=b;
        if(buf2[j-1]=='A')          //termination
        {
            lcd_clear();
            i++;
            store(buf2,config_gateway,j);

            lcd_putsf("Set Mac Address");
            lcd_gotoxy(0,1);
            j=0;

        }
        goto co1omn1;
    }

case 6:
    {
        buf2[j++]=b;
        if(buf2[j-1]=='A')          //termination
        {
            lcd_clear();
            i++;
            store(buf2,config_mac_address,j);

            lcd_putsf("Server Address");
            lcd_gotoxy(0,1);
            j=0;

        }
        goto co1omn1;

    }
case 7:
    {
        buf2[j++]=b;
        if(buf2[j-1]=='A')          //termination
        {
            lcd_clear();
            i++;
            store(buf2,config_dst_ip_address,j);
            goto begin;

        }

    }
case 8:
    {
    lcd_clear();
    lcd_putsf("Starting........");
    goto tcp;
    }


}//end switch
}//end if
}//end keypad loop


/*****************************************************
Initializition
*****************************************************/

operate:

  setGAR(config_gateway);              // Set default gateway
  setSUBR(config_subnet_mask);         // Set subnet mask
  setSHAR(config_mac_address);         // Set mac address
  setSIPR(config_ip_address);          // Set ip address

  Alarm=0;

tcp:


open_socket(TCP,Sock0,source_port_number);      //open a TCP socket

while (1)
{



if(Alarm)                                       //if Alarm is detected -> connect to server
{
    client_mode:
        mode=1;
        wr_dst_addr_TCP(Sock0,config_dst_ip_address,config_dst_port_address);
        Connect_TCP(Sock0);
}
else
{
    server_mode:
        mode=2;
        Listen_TCP(Sock0);
        while (wiz_rd(Sn_SR(Sock0)) == SOCK_LISTEN)
            {
                if(Alarm)                                       //if Alarm is detected -> connect to server
                {
                lcd_clear();
                lcd_putsf("Alarm Detected");
                goto tcp;
                }
            };    //wait for request
}


/*****************************************************
Reading
*****************************************************/


  while (wiz_rd(Sn_SR(Sock0)) == SOCK_ESTABLISHED)
  {
    Listen:
    if(Alarm)                                       //if Alarm is detected -> connect to server
    {
        lcd_clear();
        lcd_putsf("Alarm Detected");
        goto tcp;
    }
    else
        if(mode==1)//  && !Alarm                  //souhld be rare but possible              //if mode ==1 and there is no alarm
        goto tcp;
    lcd_clear();
    lcd_putsf("Waiting for data");

    rtc_get_date(&d,&mm,&y);
	rtc_get_time(&h,&m,&s);

    if(h==h_temp && m>(m_temp+15+minutes) )           //If 15 minutes spent after alarm was detected and remained ,, retransmit alarm for other 5 minutes
        {
        count2=1;                             //reset timing
        goto send_alarm;
        }

  if(mode==2)                                       //if acting like a server eg: no alarm detected
   while (wiz_rd(Sn_RX_RSR0(socket_no)) != 0 || wiz_rd(Sn_RX_RSR1(socket_no)) != 0)  //Check to know if data is received from remote peer or not.
   {
    if(Alarm)                                       //if Alarm is detected -> connect to server
    {
        goto tcp;
    }

    get_size=recieve(TCP,Sock0,packet);
    if(!get_size)   goto exit;

if(!count1)                                   //if it is first attempt
if(packet[TCP_data]==pass[0])
if(packet[TCP_data+1]==pass[1])
if(packet[TCP_data+2]==pass[2])
if(packet[TCP_data+3]==pass[3])
    {
    Authentication=1;               //password is correct
    count1=1;
    for(i=0;i<2;i++)
    {
    packet[TCP_data+i]=ack1[i];
    }
    transmit(TCP,Sock0,2,packet);   //ack as OK
    goto Listen;
    }



if(Authentication)                   //Start executing Commands
if(stage==1)
if(packet[TCP_data]=='d')         //first command "dstip change"
if(packet[TCP_data+1]=='s')         //response is "Insert IP"
if(packet[TCP_data+2]=='t')
if(packet[TCP_data+3]=='i')
if(packet[TCP_data+4]=='p')
if(packet[TCP_data+5]==' ')
if(packet[TCP_data+6]=='c')
if(packet[TCP_data+7]=='h')
if(packet[TCP_data+8]=='a')
if(packet[TCP_data+9]=='n')
if(packet[TCP_data+10]=='g')
if(packet[TCP_data+11]=='e')
    {
    for(i=0;i<9;i++)
    {
    packet[TCP_data+i]=ack2[i];
    }
    transmit(TCP,Sock0,9,packet);
    stage++;
    goto Listen;
    }

if(Authentication)                           //Get New destination IP number
if(stage==2)
{
j=15;
for(i=0;packet[TCP_data+i]!=' ';i++)
{
dest_ip_temp[i]=packet[TCP_data+i];
};
dest_ip_temp[i]=' ';//add terminator         //i=size

store_int(dest_ip_temp,config_dst_ip_address,i);
for(i=0;i<2;i++)
{
packet[TCP_data+i]=ack1[i];
}
transmit(TCP,Sock0,2,packet);
stage=1;
goto Listen;                        //wait further commands
}


if(Authentication)                   //Start executing Commands
if(stage==1)
if(packet[TCP_data]=='t')         //second command "turn on lights"
if(packet[TCP_data+1]=='u')         //response is "OK"
if(packet[TCP_data+2]=='r')
if(packet[TCP_data+3]=='n')
if(packet[TCP_data+4]=='o')
if(packet[TCP_data+5]=='n')
if(packet[TCP_data+6]==' ')
if(packet[TCP_data+7]=='l')
if(packet[TCP_data+8]=='i')
if(packet[TCP_data+9]=='g')
if(packet[TCP_data+10]=='h')
if(packet[TCP_data+11]=='t')
    {
    light =1;
    for(i=0;i<2;i++)
    {
    packet[TCP_data+i]=ack1[i];
    }
    transmit(TCP,Sock0,2,packet);   //ack as OK
    goto Listen;
    }



if(Authentication)                   //Start executing Commands
if(stage==1)
if(packet[TCP_data]=='t')         //third command "turn off lights"
if(packet[TCP_data+1]=='u')         //response is "OK"
if(packet[TCP_data+2]=='r')
if(packet[TCP_data+3]=='n')
if(packet[TCP_data+4]=='o')
if(packet[TCP_data+5]=='f')
if(packet[TCP_data+6]=='f')
if(packet[TCP_data+7]==' ')
if(packet[TCP_data+8]=='l')
if(packet[TCP_data+9]=='i')
if(packet[TCP_data+10]=='g')
if(packet[TCP_data+11]=='h')
if(packet[TCP_data+12]=='t')
    {
    light =0;
    for(i=0;i<2;i++)
    {
    packet[TCP_data+i]=ack1[i];
    }
    transmit(TCP,Sock0,2,packet);   //ack as OK
    goto Listen;
    }


if(Authentication)                   //Start executing Commands
if(stage==1)
if(packet[TCP_data]=='t')         //third command "turn on alarm"
if(packet[TCP_data+1]=='u')         //response is "OK"
if(packet[TCP_data+2]=='r')
if(packet[TCP_data+3]=='n')
if(packet[TCP_data+4]=='o')
if(packet[TCP_data+5]=='n')
if(packet[TCP_data+7]==' ')
if(packet[TCP_data+8]=='a')
if(packet[TCP_data+9]=='l')
if(packet[TCP_data+10]=='a')
if(packet[TCP_data+11]=='r')
if(packet[TCP_data+12]=='m')
    {
    for(i=0;i<2;i++)
    {
    packet[TCP_data+i]=ack2[i];
    }
    minutes=0;
    goto Listen;
    }

if(Authentication)                   //Start executing Commands
if(stage==1)
if(packet[TCP_data]=='t')         //third command "turn off alarm"
if(packet[TCP_data+1]=='u')         //response is "How long"
if(packet[TCP_data+2]=='r')
if(packet[TCP_data+3]=='n')
if(packet[TCP_data+4]=='o')
if(packet[TCP_data+5]=='f')
if(packet[TCP_data+6]=='f')
if(packet[TCP_data+7]==' ')
if(packet[TCP_data+8]=='a')
if(packet[TCP_data+9]=='l')
if(packet[TCP_data+10]=='a')
if(packet[TCP_data+11]=='r')
if(packet[TCP_data+12]=='m')

    {
    for(i=0;i<8;i++)
    {
    packet[TCP_data+i]=ack3[i];
    }
    transmit(TCP,Sock0,8,packet);
    stage++;
    goto Listen;
    }

if(Authentication)                          //Get how long the alrarm would be turned off
if(stage==2)
{
minutes= packet[TCP_data];
for(i=0;i<2;i++)
{
packet[TCP_data+i]=ack1[i];
}
transmit(TCP,Sock0,2,packet);
stage=1;
goto Listen;                        //wait further commands
}

if(Authentication)                   //Start executing Commands
if(stage==1)
if(packet[TCP_data]=='e')         //Last command "exit"
if(packet[TCP_data+1]=='x')         //response is "OK"
if(packet[TCP_data+2]=='i')
if(packet[TCP_data+3]=='t')
    {
    for(i=0;i<2;i++)
    {
    packet[TCP_data+i]=ack1[i];
    }
    transmit(TCP,Sock0,2,packet);
    Authentication=0;
    stage=0;
    goto Listen;
    }



/*****************************************************
Client ,Alarm Activated , Motion Sensed
*****************************************************/


     }    //end while data recieved


    else  //mode=1                          //if client

     {
     send_alarm:
     if(!count2)                           //Set first alert time
        {
        rtc_get_date(&d_temp,&mm_temp,&y_temp);
	    rtc_get_time(&h_temp,&m_temp,&s_temp);
	    count2=1;
        }

        rtc_get_date(&d,&mm,&y);
	    rtc_get_time(&h,&m,&s);

        if(h==h_temp && m<(m_temp+5))           //keep alarm for only 5 minutes if human motion is still sensed

	    for(i=0;i<13;i++)
        {
        packet[TCP_data+i]=alarm1[i];
        }
        packet[TCP_data+i]=' ';
        packet[TCP_data+i+1]='i';
        packet[TCP_data+i+2]='n';
        packet[TCP_data+i+8]=' ';
        packet[TCP_data+i+3]=d;
        packet[TCP_data+i+4]='/';
        packet[TCP_data+i+5]=mm;
        packet[TCP_data+i+6]='/';
        packet[TCP_data+i+7]=y;
        packet[TCP_data+i+8]=' ';
        packet[TCP_data+i+9]='a';
        packet[TCP_data+i+10]='t';
        packet[TCP_data+i+11]=' ';
        packet[TCP_data+i+12]=h;
        packet[TCP_data+i+13]=':';
        packet[TCP_data+i+14]=m;
        packet[TCP_data+i+15]=':';
        packet[TCP_data+i+16]=s;

        transmit(TCP,Sock0,31,packet);
        goto Listen;

     }    //end else if alarm

     }     //end while SOCK_ESTABLISHED


    exit: check_disconnect(TCP,Sock0);

};




}

/*****************************************************
Initialization
*****************************************************/
void initialize()
{
  volatile unsigned char IOReg;
// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 115200
UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x03;


PORTA=0x00;
DDRA=0xFF;

DDRD.4=1;//Lights Relay
DDRD.2=0;//PIR

DDRC=0xF0;
PORTC=0xFF;

//   Configure I/O pins
  DDRB = (1<<MOSI) | (1<<SCK) | (1<<SLAVE_SELECT);//OUTPUT
  DDRB &=~(1<<MISO);                                             //INPUT

  PORTB |=  (1<<SLAVE_SELECT) ;       // Disable slave
//SPI
  SPCR = (1<<SPE)| (1<<MSTR);  //SPI Enable     //Master mode
  IOReg   = SPSR;
  IOReg   = SPDR;
  delay_ms(10);
//   Configure I/O pins
  DDRB  |=  (1<<PIN_RESET) ; // OUTPUT to control the wiznet reset
  PORTB |=  (1<<PIN_RESET) ; // no reset
  delay_ms(10);
  PORTB &= ~(1<<PIN_RESET) ; //reset the module
  delay_ms(10);
  PORTB |=  (1<<PIN_RESET) ;
  delay_ms(10);
}

/*****************************************************
Set Initial IP registers
*****************************************************/

void setGAR(unsigned char *addr)
{
  // default gateway
  wiz_wr((GAR0 + 0),addr[0]);
  wiz_wr((GAR0 + 1),addr[1]);
  wiz_wr((GAR0 + 2),addr[2]);
  wiz_wr((GAR0 + 3),addr[3]);
}

void setSUBR(unsigned char * addr)	/**< a pointer to a 4 -byte array responsible to set the SubnetMask address */
{
	wiz_wr((SUBR0 + 0),addr[0]);
	wiz_wr((SUBR0 + 1),addr[1]);
	wiz_wr((SUBR0 + 2),addr[2]);
	wiz_wr((SUBR0 + 3),addr[3]);
}

void setSHAR(unsigned char * addr)	/**< a pointer to a 6 -byte array responsible to set the MAC address. */
{
	wiz_wr((SHAR0 + 0),addr[0]);
	wiz_wr((SHAR0 + 1),addr[1]);
	wiz_wr((SHAR0 + 2),addr[2]);
	wiz_wr((SHAR0 + 3),addr[3]);
	wiz_wr((SHAR0 + 4),addr[4]);
	wiz_wr((SHAR0 + 5),addr[5]);
}

void setSIPR(unsigned char * addr)	/**< a pointer to a 4 -byte array responsible to set the Source IP address. */
{
	wiz_wr((SIPR0 + 0),addr[0]);
	wiz_wr((SIPR0 + 1),addr[1]);
	wiz_wr((SIPR0 + 2),addr[2]);
	wiz_wr((SIPR0 + 3),addr[3]);
}
/*****************************************************
Reading and Writing Wiznet Registers
*****************************************************/
unsigned char wiz_rd(unsigned int address)
{
 unsigned char data = 0x00;

 PORTB &= ~(1<<SLAVE_SELECT) ; //enable slave

 spi_transfer(WIZNET_OPCODE_READ);
 spi_transfer((address>>8) & 0x00FF);
 spi_transfer(address& 0x00FF);
 data = spi_transfer(DUMMY_DATA);

 PORTB |=  (1<<SLAVE_SELECT) ;       // Disable slave

  return data;
}

void wiz_wr(unsigned int address, unsigned int targetValue)
{

 PORTB &= ~(1<<SLAVE_SELECT) ; //enable slave

 spi_transfer(WIZNET_OPCODE_WRITE);
 spi_transfer((address>>8) & 0x00FF);
 spi_transfer(address & 0x00FF);
 spi_transfer(targetValue);

 PORTB |=  (1<<SLAVE_SELECT) ;  // Disable slave
}



/*****************************************************
SPI
*****************************************************/
unsigned char spi_transfer(volatile unsigned char data)
{
  SPDR = data;                    // Start the transmission
  while (!(SPSR & (1<<SPIF)));     // Wait for the end of the transmission
  return SPDR;                    // return the received byte
}
 /*****************************************************
Listening and Connecting
*****************************************************/


unsigned char Listen_TCP(unsigned char socket_no)
{
unsigned char ret;
	if (wiz_rd(Sn_SR(socket_no)) == SOCK_INIT)
	{
		wiz_wr(Sn_CR(socket_no),Sn_CR_LISTEN);
		ret = 1;
	}
	else
	{
		ret = 0;
	}
return ret;
}
unsigned char Connect_TCP(unsigned char socket_no)
{
unsigned char ret;
	if (wiz_rd(Sn_SR(socket_no)) == SOCK_INIT)
	{
		wiz_wr(Sn_CR(socket_no),Sn_CR_CONNECT);
		ret = 1;
	}
	else
	{
		ret = 0;
	}
return ret;
}

 /*****************************************************
Sockets
*****************************************************/

void open_socket(unsigned char socket_type,unsigned char socket_no,unsigned int port_no)
 {
    if(socket_type==TCP)
	  {
	  do{
	  wiz_wr(Sn_MR(socket_no),Sn_MR_TCP);				//protocol = TDP
	  wiz_wr(Sn_PORT0(socket_no),(port_no>>8) & 0x00FF);				//well-know ECHO port
	  wiz_wr(Sn_PORT1(socket_no),port_no & 0x00FF);        //set source port
	  wiz_wr(Sn_CR(socket_no),Sn_CR_OPEN);			//give the open command
	  if(wiz_rd(Sn_SR(socket_no)) != SOCK_INIT)		//wait for the socket to come online
		  wiz_wr(Sn_CR(socket_no),Sn_CR_CLOSE);    //close socket if not open correctly
		}
	  while(wiz_rd(Sn_SR(socket_no)) != SOCK_INIT);
	  }
 }

unsigned int get_sock_size(unsigned char socket_type,unsigned char socket_no)
{
unsigned int hi_byte,lo_byte,get_size;
  if(socket_type==TCP)
  {
   hi_byte = wiz_rd(Sn_RX_RSR0(socket_no));              //get size of the packet in the "recieve size" register  RSR
	lo_byte = wiz_rd(Sn_RX_RSR1(socket_no));
	get_size = make16(hi_byte,lo_byte);                     //make a 16 bit size
	return get_size;
  }
}

unsigned int get_WR_offset(unsigned char socket_type,unsigned char socket_no)
{
unsigned int hi_byte,lo_byte,get_offset;
  if(socket_type==TCP)
  {
  hi_byte = wiz_rd(Sn_TX_WR0(socket_no));           //Read the TX Write Pointer Register
	lo_byte = wiz_rd(Sn_TX_WR1(socket_no));
	get_offset = make16(hi_byte,lo_byte) & gS0_TX_MASK; // first 11 bits required of the offset
	return get_offset;
  }
}

unsigned int get_RD_offset(unsigned char socket_type,unsigned char socket_no)
{
unsigned int hi_byte,lo_byte,get_offset;
  if(socket_type==TCP)
  {
	hi_byte = wiz_rd(Sn_RX_RD0(socket_no));               // read the "RX read pointer" register value
	lo_byte = wiz_rd(Sn_RX_RD1(socket_no));
	get_offset = make16(hi_byte,lo_byte) & gS0_RX_MASK;     // first 11 bits required of the offset
	return get_offset;
  }
}

unsigned int check_TX_buffer(unsigned char socket_type,unsigned char socket_no)
{
unsigned int hi_byte,lo_byte,get_free_size;
  if(socket_type==TCP)
  {
    hi_byte = wiz_rd(Sn_TX_FSR0(socket_no));          // Read Transmitter free size register
	  lo_byte = wiz_rd(Sn_TX_FSR1(socket_no));
	  get_free_size = make16(hi_byte,lo_byte);            //Get the TX Buffer Free size
	  return get_free_size;

  }
}

void wr_dst_addr_TCP(unsigned char socket_no,unsigned char *config_dst_ip_address,unsigned char *config_dst_port_address )
{
unsigned int addri;
int i8;
         addri = Sn_DIPR0(socket_no);                                //Get the address of the "destination IP address register"
	      for(i8=0;i8<4;++i8)
		   wiz_wr(addri++,config_dst_ip_address[i8]);//Write the destination IP address to send
	      addri = Sn_DPORT0(socket_no);                               //Get the address of the "destination PORT address register"
	      for(i8=0;i8<2;++i8)
		      wiz_wr(addri++,config_dst_port_address[i8]);//Write the destination PORT address to send
}

/*****************************************************
Disconnecting
*****************************************************/

void sock_close(unsigned char socket_type,unsigned char socket_no)
{
   if(socket_type==TCP)
      {
      wiz_wr(Sn_CR(socket_no),Sn_CR_CLOSE);        //close socket
      }
}

void check_disconnect(unsigned char socket_type,unsigned char socket_no)
{
 if(socket_type==TCP)
   {
        if(wiz_rd(Sn_SR(socket_no)) == SOCK_CLOSE_WAIT || wiz_rd(Sn_SR(socket_no))==SOCK_CLOSED ||wiz_rd(Sn_IR(socket_no))&0x0A )
		   {
		   wiz_wr(Sn_CR(socket_no),Sn_CR_CLOSE);        //close socket
		   open_socket(TCP,socket_no,source_port_number);      //open a TCP socket
		   if(wiz_rd(Sn_IR(socket_no))&0x0A)
		   wiz_wr(Sn_IR(socket_no),0x0A);//clear registers
		   printf("&");
		   }
   }
}

void disconnect(unsigned char socket_type,unsigned char socket_no)
{
   if(socket_type==TCP)
      wiz_wr(Sn_CR(socket_no),Sn_CR_DISCON);        //close socket
}

/*****************************************************
Transmission and Reception
*****************************************************/

void transmit(unsigned char socket_type,unsigned char socket_no,unsigned char get_size,unsigned char *packet)
{

unsigned int get_offset,get_start_address;
unsigned int get_free_size;
int i8;
unsigned int addri;

      // first, get the free TX memory size
      do
      {
         get_free_size=check_TX_buffer(TCP,Sock0);           //Get the TX Buffer Free size
      }
      while(get_free_size < get_size);

      get_offset=get_WR_offset(TCP,Sock0);                //Get the write offset

	   get_start_address = gS0_TX_BASE + get_offset;       //Get beginning address where the UDP data are stored
	   addri = get_start_address;

//No need for more than 2 KBs in our application
/*
	   if ( (get_offset + get_size) > (gS0_RX_MASK + 1) ) //Sock0
         {
           //store UDP header

           // copy upper_size bytes of get_start_address to destination_addr
           upper_size = (gS0_RX_MASK + 1) - get_offset ;
	          for(i8=0;i8<upper_size;++i8)
	            {
		          		wiz_wr(addri++,packet[TCP_data+i8]);
		               ++get_offset;
	            }
            // copy left_size bytes of gSn_RX_BASE to destination_addr
            left_size = get_size - upper_size;

	         for(i8=0;i8<left_size;++i8)
	          {
		         wiz_wr(gS0_TX_BASE+i8,packet[TCP_data + upper_size+i8]);
	          }


         }//end if
      else
 */
	   for(i8=0;i8<get_size;++i8)                     //Write the UDP data to the TX buffer
	   {
		   wiz_wr(addri++,packet[TCP_data+i8]);
		   ++get_offset;
		   printf("-%c-",packet[TCP_data+i8]);
	   }
	   wiz_wr(Sn_TX_WR0(socket_no),(make8(get_offset,1)));
	   wiz_wr(Sn_TX_WR1(socket_no),(make8(get_offset,0)));
	   wiz_wr(Sn_CR(socket_no),Sn_CR_SEND);             //Send data
	   while(wiz_rd(Sn_CR(socket_no)));                  //wait for the data to be transmitted

}

unsigned char recieve(unsigned char socket_type,unsigned char socket_no,unsigned char *packet)
{

unsigned int get_size, get_offset,get_start_address;
int i8;
unsigned int addri;
      get_size=get_sock_size(TCP,Sock0);                      //get the socket size
      if(get_size==2048)                                      //at very rare situations this happens ,,it killed me
        {
            wiz_wr(Sn_CR(socket_no),Sn_CR_DISCON);
            return 0;
        }
	 printf("-3-");
	   get_offset=get_RD_offset(TCP,socket_no);                  //get the read offset
	   get_start_address = gS0_RX_BASE + get_offset;           //Get beginning address of the UDP packets header
        printf("-4-");
      addri = get_start_address;

//No need for more than 2 KBs in our application

/*    // if overflow socket RX memory
      if ( (get_offset + get_size) > (gS0_RX_MASK + 1) ) //Sock0
      {
        printf("-*-"); printf("+%d+",get_size);
            //store UDP header

            // copy upper_size bytes of get_start_address to destination_addr
            upper_size = (gS0_RX_MASK + 1) - get_offset ;
	            for(i8=0;i8<upper_size;++i8)
	            {
		            packet[TCP_data+i8] = wiz_rd(addri++);
	            }
               // copy left_size bytes of gSn_RX_BASE to destination_addr
               left_size = get_size - upper_size;

	            for(i8=0;i8<left_size;++i8)
	               {
		            packet[TCP_data + upper_size+i8] = wiz_rd(gS0_TX_BASE+i8);
	               }


       }//end if


      //else      */

// copy get_size bytes of get_start_address to destination_addr
	         for(i8=0;i8<get_size;++i8)
	            {
		            packet[TCP_data+i8] = wiz_rd(addri++);
		            ++get_offset;
		            printf("-%d-",i8);
	            }
	         printf("-6-");
            // increase Sn_RX_RD as length of get_size
             printf("-7-");
         	wiz_wr(Sn_RX_RD0(socket_no),(make8(get_offset,1)));
	         wiz_wr(Sn_RX_RD1(socket_no),(make8(get_offset,0)));

	          printf("-8-");
      wiz_wr(Sn_CR(socket_no),Sn_CR_RECV);             //reset recieved data interrupt bit
	  return get_size;
}

/*****************************************************
Storing Arrays
*****************************************************/

void store(unsigned char *src,unsigned char *dest,unsigned char size)
{
int k,l=0,b=0;
for(k=0;k<size;k++)
            {
                if(src[k]=='*')
                    src[k]=src[k-1];
                if(src[k]=='.' || src[k]=='A'/*Termination*/)
                    {
                    if(!b)              //first number ,b points to first digit
                    switch (k-b)
                        {
                        case 1:  // 1 digit
                            dest[l++]=src[k-1];
                            break;

                        case 2:  // 2 digits
                            dest[l++]=src[k-1]+src[k-2]*10;
                            break;
                        case 3:  // 3 digits
                            dest[l++]=src[k-1]+src[k-2]*10+src[k-3]*100;
                            break;
                        }
                    else
                    switch (k-b)     //the rest ,b points to '.'
                        {
                        case 2:  // 1 digit
                            dest[l++]=src[k-1];
                            break;

                        case 3:  // 2 digits
                            dest[l++]=src[k-1]+src[k-2]*10;
                            break;
                        case 4:  // 3 digits
                            dest[l++]=src[k-1]+src[k-2]*10+src[k-3]*100;
                            break;
                        }
                     }
                }
}

void store_int(unsigned char *src,unsigned char *dest,unsigned char size)
{
int k,l=0,b=0;
for(k=0;k<size;k++)
            {

                if(src[k]=='.' || src[k]==' '/*Termination*/)
                    {
                    if(!b)              //first number ,b points to first digit
                    switch (k-b)
                        {
                        case 1:  // 1 digit
                            dest[l++]=src[k-1];
                            break;

                        case 2:  // 2 digits
                            dest[l++]=src[k-1]+src[k-2]*10;
                            break;
                        case 3:  // 3 digits
                            dest[l++]=src[k-1]+src[k-2]*10+src[k-3]*100;
                            break;
                        }
                    else
                    switch (k-b)     //the rest ,b points to '.'
                        {
                        case 2:  // 1 digit
                            dest[l++]=src[k-1];
                            break;

                        case 3:  // 2 digits
                            dest[l++]=src[k-1]+src[k-2]*10;
                            break;
                        case 4:  // 3 digits
                            dest[l++]=src[k-1]+src[k-2]*10+src[k-3]*100;
                            break;
                        }
                     }
                }
}


